/** La clase bomba contiene la interfaz gráfica de la bomba y los 
 * atributos necesarios para que el funcionamiento de la bomba sea correcto.
 * Esta clase será la case padre de BombaEntrada y BombaSalida, implementando
 * los métodos para poder conocr y modificar atributos.
 * 
 */
import java.awt.Color;
import java.awt.Container;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.geom.Rectangle2D;
import javax.swing.JSlider;

public class Bomba {
    private double caudal;
    private double voltage;
    private Container container;  // Container where the cabina is contained.
    private ViewAgua view;
    private ViewBomba view1;
    private int prop_caudal;
    private int resid_caudal;
    private double Agua_tubo;
    private int AnchoTubo;
    private Slider Svoltage;
    private double voltagep;
    private int tBomba;
    
    public Bomba(int volt, int a, int b,int altura, int ancho,int iniciox,int inicioy,int largo,int anchoT,int largoT, int inx,int iny,int inixa, int tb)
    {   
        voltage=volt;
        tBomba=tb;
        prop_caudal=a;
        resid_caudal=b;
        Agua_tubo=0.0;
        AnchoTubo=anchoT;
        container=null;
        view = new ViewAgua(inixa,inicioy,ancho,anchoT, largoT);
        view1 = new ViewBomba(iniciox,inicioy,ancho,altura,largo, anchoT, largoT, inx, iny);
    }
    
    
    
    public double get_caudal()
    {
        return caudal;
    }
    
    public void calculo_caudalM()
    {
        caudal=prop_caudal*Svoltage.getValor() + resid_caudal;
        if(Svoltage.getValor()==0){
            Agua_tubo=0;
        }
        else{
          Agua_tubo=2*AnchoTubo-0.9;  
        }
        
    }
    
    public void calculo_caudalPID()
    {
        caudal=prop_caudal*voltagep + resid_caudal;
        if(voltagep==0){
            Agua_tubo=0;
        }
        else{
          Agua_tubo=2*AnchoTubo-0.9;  
        }
        
        
    }
    
    public void set_caudal(double i)
    {
        caudal=i;
        Svoltage.set_valor(0);
    }
    
    public double get_voltage()
    {
        return voltage;
    }
    
    public double get_Svoltage()
    {
        return Svoltage.getValor();
    }
    
     public void setContainer(Container c){
      container = c;
   }
   public ViewAgua getView() {
      return view;
   }  
   
   public ViewBomba getView1() {
      return view1;
   }  
   
   public void AddSlider(Slider Slider1){
        Svoltage=Slider1;
   }
   public void set_voltage(double volt){
    	voltagep = volt;
    }

    public class ViewAgua extends Rectangle2D.Double {
      private double width,Wt,Ht,Wit;
      private double inix,iniy;
      private ViewAgua(double inx,double iny,double w, double wt,double ht){
        width=w;
        inix=inx;
        iniy=iny+1;
        Wit=wt;
        Wt=Wit;
        Ht=ht;
      }
      private void setPosition(float position){
         setFrame(0.0, 0.0, width, height);      
      }
            
      public void draw (Graphics2D g){
         Rectangle2D.Double view;
         Rectangle2D.Double view1;
         view = new Rectangle2D.Double(inix,iniy, Ht+1, Agua_tubo);
         //view1 = new Rectangle2D.Double(dirx,iniy+height, width+6, width);
         g.setColor(new Color(0,0,255));
         g.fill(view);
         //g.fill(view1);
      }
   }
    
    public class ViewBomba extends Rectangle2D.Double {
      private int width, height, inix ,iniy, lar, TuboArea, TuboLargo, inixt,iniyt;
      private ViewBomba(int inx, int iny, int w, int h,int larg,int TA, int TL, int inxt, int inyt){
       width=w;
        height=h;
        inix=inx+1;
        iniy=iny;
        lar=(int) (larg*0.707/2);
        TuboArea=TA;
        TuboLargo=TL;
        inixt=inxt;
        iniyt=inyt;
        }
     private void setPosition(float position){
        setFrame(0.0, 0.0, width, height);      
      }
      public void draw (Graphics2D g){
         Rectangle2D.Double view;
                
         //grafica bomba
         g.setColor(new Color(0,0,0));
          //dibujo de la cara frontal
        
         view = new Rectangle2D.Double(inix,iniy, width, height);
         g.fill(view);
         
         //dibujo poligono superior
         int Puntosx1[]={inix,width+inix,width+inix+lar,inix+lar};
         int Puntosy1[]={height+iniy,height+iniy,height+iniy+lar,height+iniy+lar};
         Polygon polygon1=new Polygon(Puntosx1,Puntosy1,4);
         g.fillPolygon(polygon1);
         
         //dibujo poligono borde derecho
         g.setColor(new Color(0,0,0));
         int Puntosx2[]={width+inix,width+inix,inix+width+lar,inix+width+lar};
         int Puntosy2[]={iniy,height+iniy,height+iniy+lar,iniy+lar};
         Polygon polygon2=new Polygon(Puntosx2,Puntosy2,4);
         g.fillPolygon(polygon2);
         
           view = new Rectangle2D.Double(inixt,iniy+1, TuboLargo, 2*TuboArea-0.5);
         g.setColor(new Color(200,200,200));
         g.fill(view);
          //grafica tubo bomba
          g.setColor(new Color(100,100,100));
         g.drawLine (inixt, iniy+1, inixt+TuboLargo,iniy+1);
         g.drawLine (inixt, iniy+2*TuboArea+1, inixt+TuboLargo, iniy+2*TuboArea+1);
         
      }
   }
    
        
   }