/**Esta clase se preocupa del control del sistema y de su vista en la interfaz.
 * El controlador PID es sólo un método, por lo que si se desea crear un nuevo
 * controlador, se puede agregar otro método.
 * 
 */
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class Controlador {
    public  JPanel panelPrincipal;
    private JPanel panelP;
    private JPanel panelI;
    private JPanel panelD;
    public Slider sliderP= new Slider(0,10,1);
    public Slider sliderI= new Slider(0,10,1);
    public Slider sliderD= new Slider(0,10,1);
    public JLabel label1=new JLabel("0.0",JLabel.CENTER);
    public JLabel label2=new JLabel("0.0",JLabel.CENTER);
    public JLabel label3=new JLabel("0.0",JLabel.CENTER);
    public double error1;
    public double error2;
    public double errSum1=0;
    public double errSum2=0;
    public double lastErr1=0;
    public double lastErr2=0;
    
    public Controlador(){
        //creacion del panel de nombre
        panelPrincipal= new JPanel();
        panelPrincipal.setLayout(new GridLayout(4,1));
        panelPrincipal.setBorder(BorderFactory.createLineBorder(Color.black));
        panelPrincipal.add(new JLabel("Controlador",JLabel.CENTER));
        //panel controlador P
        panelP= new JPanel();
        panelP.setLayout(new FlowLayout());
        panelP.add(new JLabel("P"));
        panelP.add(sliderP.getSlider());
        panelP.add(label1);
        label1.setBorder (BorderFactory.createLineBorder(Color.red, 1));
        //panel controlador I
        panelI= new JPanel();
        panelI.setLayout(new FlowLayout());
        panelI.add(new JLabel("I"));
        panelI.add(sliderI.getSlider());
        panelI.add(label2);
        label2.setBorder (BorderFactory.createLineBorder(Color.red, 1));
        //panel controlador D
        panelD= new JPanel();
        panelD.setLayout(new FlowLayout());
        panelD.add(new JLabel("D"));
        panelD.add(sliderD.getSlider());
        panelD.add(label3);
        label3.setBorder (BorderFactory.createLineBorder(Color.red, 1));
        
        panelPrincipal.add(panelP);
        panelPrincipal.add(panelI);
        panelPrincipal.add(panelD);
    }
    
    public JPanel getJpanel(){
        return panelPrincipal;
    } 
    
    public Slider getSliderP(){
        return sliderP;
    }
    
     public Slider getSliderI(){
        return sliderI;
    }
     
      public Slider getSliderD(){
        return sliderD;
    }
   
       public void set_label(){
            label1.setText(String.valueOf(sliderP.getValor()));
            label2.setText(String.valueOf(sliderI.getValor()));
            label3.setText(String.valueOf(sliderD.getValor()));
    }
       
     public void blok_seccion(){
    
        sliderP.blokear_slider();
        sliderI.blokear_slider();
        sliderD.blokear_slider();
    }
    
    public void Dblok_seccion(){
    
        sliderP.desblokear_slider();
        sliderI.desblokear_slider();
        sliderD.desblokear_slider();
    }
    
    public void PID(double ref1,double ref2, Bomba in, Bomba out,Estanque ein, Estanque eout){
    	/*se asume ref en voltaje, si se desea en altura hay que
    	 * utilizar la siguiente conversión (Para 4 estanques)
    	 * h1=(1000*v1-v1*1000/A)*t aca A=25*3
    	 * h2=((1000/A)*v1*(t-0.001)-v2*1000*t/Abs  Donde Abs es el area de la bomba de salida.
    	 * Se estiman los valores segun resultados vistos.
    	 */
    	double v1, v2;
    	   	error1 = ref1 - ein.get_altura() ; 
	    	error2 = eout.get_altura()-ref2   ; 
	    	errSum1 += error1;
	    	errSum2 += error2;
			v1 = sliderP.getValor()*error1 + errSum1 * sliderI.getValor()/5000+ ((error1 - lastErr1)*sliderD.getValor()/ 100)/1000; 		
			v2 = sliderP.getValor()*error2 + errSum2 * sliderI.getValor()/5000+ ((error2 - lastErr2)*sliderD.getValor()/ 100)/1000;
			lastErr1 = error1;
			lastErr2 = error2;
			in.set_voltage(v1);
			out.set_voltage(v2);
                        System.out.println("se calcula el nuevo voltage 1"+v1);
    	}
		
    

}
    

