/** Todas las variables del estanque son atributos que 
 * que se pueden obtener o modificar mediante los metodos que se implementan.
 * Será la clase padre de EstanqueFinal EstanqueInicial y EstanqueIntermedio.
 * 
 */
import java.awt.Color;
import java.awt.Container;
import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;
import java.awt.Polygon;

public class Estanque {
    public double CantAgua;//cantidad de agua del estanque (cm^3)
    public double VolumenE;//volumen del estanque (cm^3)
    public double altura;//centimetros
    public int area;//centimetros
    private int alto;//centimetros altura del estanque
    public int altuT;//altura de la tapa en 3d 
    private Container container;  // Container where the cabina is contained.
    private ViewAgua view;
    private ViewEstanque view1;
    
    public Estanque(int larg,int anch, int alto,int pox, int poy,int inder,int inizq)
    {
        area=larg*anch;
        altuT=0;
        CantAgua=0;
        altura=CantAgua/area;
        VolumenE= area*alto;
        container=null;
        view = new ViewAgua(pox,poy,anch,larg,alto);
        view1= new ViewEstanque(pox,poy,anch,alto,inder,inizq,larg);
    }
    
    public double get_altura()
    {
        return altura;
    }
    
    public double get_Cagua()
    {
        return CantAgua;
    }
    
    public int get_area()
    {
        return area;
    }
    
    public void actualiza_altura()
    {
       
    }
    
     public void actualiza_CAgua(double time)
    {
       
    }
    
    public double get_caudal()
    {
        return 0;
    }
    
    
    public void setContainer(Container c){
      container = c;
   }
    
    public void repaint()
    {
     if (container!=null) 
         container.repaint();// 
    }
    
   public ViewAgua getView() {
      return view;
   }  
   
   public ViewEstanque getViewe() {
      return view1;
   }  
   
//*******************************************************************************************************   
    public class ViewAgua extends Rectangle2D.Double {
      private int width, posx ,posy, larg,height;
      private ViewAgua(int x, int y, int w,int l,int h){
        width=w;
        posx=x;
        posy=y;
        larg=(int) (l*0.707/2);;
        height=h;
      }
      private void setPosition(){
         setFrame(posx+0.6, posy, width, altura);      
      }
      public void draw (Graphics2D g){
         Rectangle2D.Double view;
         view = new Rectangle2D.Double(posx+0.6,posy+0.1, width-0.8, altura-1);
         g.setColor(new Color(0,0,255));
         g.fill(view);
         //dibujo poligono superior
         int Puntosx1[]={posx+larg-altuT,width+posx,width+posx+altuT,posx+larg};
         int Puntosy1[]={height+posy,height+posy,height+posy+altuT,height+posy+altuT};
         Polygon polygon1=new Polygon(Puntosx1,Puntosy1,4);
         g.fillPolygon(polygon1);
      }
   }
    
// ********************************************************************************************************   
   public class ViewEstanque extends Rectangle2D.Double {
      private int width, height, posx ,posy,initDer, initIzq,larg;
      private ViewEstanque(int x, int y, int w, int h,int inD,int inI,int lar){
        width=w;
        height=h;
        posx=x;
        posy=y;
        initDer=inD;
        initIzq=inI;
        larg=(int) (lar*0.707/2);
        }
      private void setPosition(float position){
         setFrame(posx, posy, width, height);      
      }
      public void draw (Graphics2D g){
          
         //dibujo de la cara frontal
         Rectangle2D.Double view;
         view = new Rectangle2D.Double(posx+0.1,posy+0.1, width, height);
         g.setColor(new Color(200,200,200));
         g.fill(view);
         
         //dibujo poligono superior
         int Puntosx1[]={posx,width+posx,width+posx+larg,posx+larg};
         int Puntosy1[]={height+posy,height+posy,height+posy+larg,height+posy+larg};
         Polygon polygon1=new Polygon(Puntosx1,Puntosy1,4);
         g.fillPolygon(polygon1);
         
         //dibujo poligono borde derecho
         g.setColor(new Color(0,0,0));
         int Puntosx2[]={width+posx,width+posx,posx+width+larg,posx+width+larg};
         int Puntosy2[]={posy,height+posy,height+posy+larg,posy+larg};
         Polygon polygon2=new Polygon(Puntosx2,Puntosy2,4);
         g.fillPolygon(polygon2);
         
         
         //dibujo de los bordes
         g.setColor(new Color(0,0,0));
         g.drawLine (posx, initIzq, posx, height+posy);//borde delanteto izquierdo
         g.drawLine (posx, posy, width+posx,posy);//borde delantero inferior
         g.drawLine (width+posx, initDer,width+posx , height+posy);//borde delantero derecho
         g.drawLine (posx, height+posy,width+posx , height+posy);//borde delantero superior 
         g.drawLine (posx+larg, height+posy+larg,width+posx+larg,height+posy+larg);//borde tacero superior 2
         g.drawLine (posx, height+posy,posx+larg,height+posy+larg);//borde superior derecho
         g.drawLine (posx+width, height+posy,posx+width+larg,height+posy+larg);//borde superior izquierdo
         g.drawLine (posx+width+larg,height+posy+larg,posx+width+larg,posy+larg);//borde tracero derecho
         g.drawLine (posx+width+larg,posy+larg,posx+width,posy);//borde tracero inferior
         
         
      }
   }
}
