/**Modela el estanque inicial, con la bomba de entrada como entrada 
 * (por donde le ingresa el agua) y la valvula de interconexion con 
 * el otro estanque como salida. 
 *
 */
public class EstanqueInicial extends Estanque {
    private Bomba entrada;
    private Valvula salida;
    private int larg;
    private int altura_estanque;
    

    public EstanqueInicial(Bomba entrad, Valvula salid, int anch,int lar, int alt,int posx, int posy)
    {
        super(lar,anch,alt,posx, posy, posy+salid.get_alto(),posy);
        entrada=entrad;
        salida=salid;
        larg=lar;
        altura_estanque=alt;
    }
    
    public void actualiza_altura()
    {
       altura=CantAgua/area;
       if(altura>(altura_estanque-(int) (larg*0.707/2))){
           altuT=(int) (altura-altura_estanque+(int) (larg*0.707/2));
       }
       else{
           altuT=0;
       }
       super.repaint();
       }
    
    public void actualiza_CAgua(double time)
    {
       double caudal_entrada= entrada.get_caudal();
       double caudal_salida= salida.get_caudal();
       double nueva_agua= (caudal_entrada-caudal_salida)*time;//cantidad de agua que entra al estanque
       if(((CantAgua+nueva_agua)>0)&&((CantAgua+nueva_agua)<VolumenE))//restringe la altura del liquido entre 0 y 500
           CantAgua=CantAgua+nueva_agua;
       else if((CantAgua+nueva_agua)<=0)
           CantAgua=0;
       else if((CantAgua+nueva_agua)>=VolumenE)
           CantAgua=VolumenE;
       }
    
    public double get_caudal()
    {
        return entrada.get_caudal();
    }
    
  }
