/** Esta clase es una de las más importantes. Tiene
 * la máquina de estados que permite iniciar, pausar 
 * el sistema y cambiar de modo manual a pid.
 * 
 */
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Timer;


public class Motor_Bombas implements ActionListener {
   private Timer timer;
   private double deltaHight;    // in [m]
   private  double time=0;
   private Bomba bomba_entrada;
   private Bomba bomba_salida;
   private Estanque estanque1;
   private Estanque estanque2;
   private Valvula valvula1;
   private Controlador PID;
   private Configuradores config;
   private PanelBotones Cbotones;
   private double altura_ref1;
   private double altura_ref2;
   public static final int STARTM =0;  // it is better to use
   public static final int STARTPID =1;  // it is better to use
   public static final int PAUSED =2;  // not seen it.
   public static final int STOPPED =3;
   
   public int state;
   
   public Motor_Bombas (Estanque est1,Estanque est2, Bomba bom_ent,Bomba bom_sal, Valvula val){
      int deltaTime = 10; // [ms]//velocidad de repeticion del timer
      state = STOPPED;//empienza en estado stop
      estanque1=est1;
      estanque2=est2;
      bomba_entrada=bom_ent;
      bomba_salida=bom_sal;
      valvula1=val;
      deltaHight = 0.01;
      timer = new Timer(deltaTime, this);
      
   }
   
   public void startManual() {//funcion que mueve el asensor hacia abajo
      if (!timer.isRunning())//si el timer esta parado
         timer.start();//inicia el timer
      state = STARTM;
   }
   
   public void startPid() {//funcion que mueve el asensor hacia abajo
      if (!timer.isRunning())//si el timer esta parado
         timer.start();//inicia el timer
      state = STARTPID;
   }
   
   public void stop() {//funcion que para el asensor y el timer
      timer.stop();
      state = STOPPED;
   }
   
   public void pause() {//funcion que pausa el asensor y espera por 2 segundos
     // int oldState =state;
      state = PAUSED;
     
   }
   
   public int getState(){//funcion que retorna el estado
      return state;
   } 
   
   public void set_configuradores(Configuradores conf){
       
       config=conf;
       PID=config.getEditorPID();
       
   }
   
   public void set_Cbotones(PanelBotones PB){
       
       Cbotones=PB;
   }
   
   public void actionPerformed (ActionEvent event) {//funcion que espera se realiza en cada cuenta del timer
      switch (state) {
         case STARTM: 
                     bomba_entrada.calculo_caudalM();
                     bomba_salida.calculo_caudalM();
                  break;
         case STARTPID:
                     altura_ref1=config.get_Slider_altura(1).getValor();
                     altura_ref2=config.get_Slider_altura(2).getValor();
                     PID.PID(altura_ref1, altura_ref2,bomba_entrada , bomba_salida,estanque1, estanque2);
                     bomba_entrada.calculo_caudalPID();
                     bomba_salida.calculo_caudalPID();
                  break;
         case PAUSED:
                    bomba_entrada.set_caudal(0.0);
                    bomba_salida.set_caudal(0.0);
                  break;
         
         
      }
      config.set_labels();
      Cbotones.set_label();
      Cbotones.set_Rboton(config.getEditorVoltage(),config.getEditorAltura(),config.getEditorPID());
      estanque1.actualiza_CAgua(deltaHight);
      valvula1.calculo_caudal();
      estanque2.actualiza_CAgua(deltaHight);
      estanque1.actualiza_altura();
      estanque2.actualiza_altura();
      time= time + deltaHight;
      /*System.out.println("******************* Tiempo "+time+"****************");
      System.out.println("El caudal de entrada es: "+bomba_entrada.get_caudal());
      System.out.println("El voltage de entrada es: "+bomba_entrada.get_voltage());
      System.out.println("El Svoltage de entrada es: "+bomba_entrada.get_Svoltage());
      System.out.println("El caudal de intermedio es: "+valvula1.get_caudal());
      System.out.println("El caudal de salida es: "+bomba_salida.get_caudal());
      System.out.println("La Altura estanque 1 es: "+estanque1.get_Cagua());
      System.out.println("La Altura estanque 2 es: "+estanque2.get_Cagua());
      System.out.println("***************************************************");*/
   }
}
    
    
    

