﻿/**PROYECTO ELO 329: SIMULADOR DE ESTANQUES
 * @author Paulo Rivera Alejandro Peralta Vanessa Pulgar
 * 
 * Para este proyecto se utilizan una gran cantidad de clases que interactuan entre sí.
 * La gracia está en como trabajan cada una de las clases, sus parametros de entrada y salida.
 *
**/
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.ScrollPane;
import java.awt.Scrollbar;
//import javafx.beans.value.ChangeListener;
//import javafx.beans.value.ObservableValue;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.*;
import javax.swing.event.ChangeEvent;

/**
 *  En el proyecto la clase ProyectoPoo es la cual contiene el main, 
 * el cual se utiliza para crear el objeto frame de la clase MyEstanquesFrame.
**/
public class ProyectoPoo {
    public static void main(String[] args) {
        MyEstanquesFrame frame = new MyEstanquesFrame();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);
        frame.setResizable(false);//tamaño de pantalla no cambia
    }
}
    
/**
 *  En la clase MyEstanquesFrame se inicializan los objetos que 
 * se utilizaran en la simulacion. Este es el lugar en que por el momento se pueden
 * setear los valores de los didtintos atributos que se quieran para los estanques, valvulas y bombas, por lo cual
 * existen muchos atributos declarados al principio.
 *
**/
class MyEstanquesFrame extends JFrame {
   public MyEstanquesFrame() {
      setTitle("My Estanques for ELO329");
      setSize(1360,730);//tamaño ventana
      Barra_menu menu1= new Barra_menu();
      setJMenuBar(menu1.get_menubar());
      
      int num_Estanques=2;
            
      //variables
      //datos bombas
      int voltage1=0;
      int a1=1000;
      int b1=0; 
      int voltage2=1;
      int a2=1000;
      int b2=0;
      
      //Datos forma bombas1
        int altura_bomba1=20;
        int ancho_bomba1=20;
        int largo_bomba1=10;
        int area_tubo_bomba1=2;
        int largo_tubo_bomba1=20;
        int iniciox_bomba1=0;
        int inicioy_bomba1=0;
        
      //Datos estanque 1
       int altura_estanques=50;
        int ancho_estanque1=100;//ancho X
        int largo_estanque1=50;//profundidad
        int inicio_estanque1=iniciox_bomba1+ ancho_bomba1+largo_tubo_bomba1;
        
        //datos valvula
        int alto_valvula1=5;
        int ancho_valvula1=5;
        int largo_valvula1=10;
        int cte_fluido_valvula1=5;
        int inicio_valvula1=inicio_estanque1+ancho_estanque1;
        
        //Datos estanque 2
        int ancho_estanque2=100;
        int largo_estanque2=50;
        int inicio_estanque2=inicio_valvula1+largo_valvula1;
                
        //Datos forma bomba 2
        int altura_bomba2=20;
        int ancho_bomba2=20;
        int largo_bomba2=20;
        int area_tubo_bomba2=2;
        int largo_tubo_bomba2=20;
        int iniciox_bomba2=inicio_estanque2+ancho_estanque2;
        int inicioy_bomba2=0;
        
       /** Las bombas de entrada y Salida se crean con las clases de igual nombre, las cuales
* heredan la clase Bomba, que contiene los metodos ylos 
* atributos necesarios para que el funcionamiento de la bomba sea correcto.
 *  Para crear las bombas se necesitan las caracteristicas que se desean en en la entrada y salida
 * del sistema.
 *
 */
        //creacion de las bombas
        Bomba bomba_entrada= new BombaEntrada(voltage1 ,a1 ,b1,altura_bomba1,ancho_bomba1,iniciox_bomba1,inicioy_bomba1,largo_bomba1,area_tubo_bomba1,largo_tubo_bomba1);
        Bomba bomba_salida= new BombaSalida(voltage2 ,a2 ,b2,altura_bomba2,ancho_bomba2,iniciox_bomba2,inicioy_bomba2,largo_bomba2,area_tubo_bomba2,largo_tubo_bomba2);
        

/** La clase valvula modela la valvula de interconexion
 * entre los estanques. Tiene su propio caudal y parametros que
 * proximamente podran ser modifcados desde el programa.
 *Para crearlo se necesitan las caracteristicas que se desean en la valvula
 * y luego se le pasa información por medio de un metodo para que conozca que esta interconectando.
 */
        //creacion de valvula
        Valvula valvula1= new Valvula(alto_valvula1,ancho_valvula1,cte_fluido_valvula1,largo_valvula1,inicio_valvula1,0);
 

       /** EstanqueInicial y EstanqueFinal son clases que modelna los estanques y heredan de la clase estanque
 * sus metodos y atributos. los metodos que tienen sirve para poder conocer y modificar sus atributos. 
 * Se inicializan con la entrada y salida que corresponda al estanque, además de las características
 * mecanicas de diseño del estanque.
 * 
 */

        //creacion de estanques
        EstanqueInicial estanque1= new EstanqueInicial(bomba_entrada,valvula1,ancho_estanque1,largo_estanque1,altura_estanques,inicio_estanque1, 0);
        EstanqueFinal estanque2= new EstanqueFinal(valvula1,bomba_salida,ancho_estanque2,largo_estanque2,altura_estanques,inicio_estanque2, 0);
        
        //seteo de los entanques en la valvula
        valvula1.set_estanques(estanque1, estanque2);
        
/** La clase Motor_Bombas es una de las mas importantes. Tiene
 * la maquina de estados que permite iniciar, pausar 
 * el sistema y cambiar de modo manual a pid.
 * Mantiene la comunicación con el controlador, y se inicializa con los estanques
 * del sistema, las bombas a las cuales dará voltaje y la valvula.
 * 
 */

        Motor_Bombas motBomba= new Motor_Bombas(estanque1, estanque2, bomba_entrada, bomba_salida,valvula1);
        
        System.out.println("Todo creado correctamente");
        
        
      
/** La inicialización de las dintintas partes de la interfaz tambien se hace en esta clase.
 * 
 */
           
    // container principal
      Container contentPane = getContentPane();
      contentPane.setLayout(new GridBagLayout());//se pone el layout
      //vision de los estanques
      JPanel panelEstanques= new JPanel();
      
      GridBagConstraints constraints1 = new GridBagConstraints();//se genera el grid layout
      constraints1.gridx = 0; // El área de texto empieza en la columna cero.
      constraints1.gridy = 0; // El área de texto empieza en la fila cero
      constraints1.gridwidth=1; // El área de texto ocupa dos columnas.
      constraints1.gridheight = 1; // El área de texto ocupa 2 filas.
      constraints1.fill = GridBagConstraints.BOTH;
      constraints1.weighty = 5.0; // La fila 0 debe estirarse, le ponemos un 1.0
      constraints1.weightx = 2.0; // La fila 0 debe estirarse, le ponemos un 1.0
      EstanqueView estanqueView1 = new EstanqueView(bomba_entrada.getView(),bomba_entrada.getView1(),bomba_salida.getView(),bomba_salida.getView1());
      estanqueView1.set_Estanques(estanque1.getView(),estanque1.getViewe(),estanque2.getView(),estanque2.getViewe());
      estanqueView1.set_Valvulas(valvula1.getView(),valvula1.getView1());
      estanque1.setContainer(contentPane); // so cabina can call repaint when it moves.
      estanque2.setContainer(contentPane); // so cabina can call repaint when it moves.
      bomba_entrada.setContainer(contentPane); // so cabina can call repaint when it moves.
      panelEstanques.setLayout(new GridLayout(1,1));
      panelEstanques.setBorder(BorderFactory.createLineBorder(Color.black));
      panelEstanques.add(estanqueView1);
      add(panelEstanques,constraints1);
      constraints1.weighty = 0.0; // La fila 0 debe estirarse, le ponemos un 1.0
      
      //***********************slider de configuracion************************************************//
      Configuradores Pconfig= new Configuradores(num_Estanques);
      GridBagConstraints constraints2 = new GridBagConstraints();//se genera el grid layout
      constraints2.gridx = 0; // El área de texto empieza en la columna cero.
      constraints2.gridy = 1; // El área de texto empieza en la fila cero
      constraints2.gridwidth =1; // El área de texto ocupa dos columnas.
      constraints2.gridheight = 1; // El área de texto ocupa 2 filas.
      constraints2.fill = GridBagConstraints.HORIZONTAL;
      constraints2.weighty = 0.1; // La fila 0 debe estirarse, le ponemos un 1.0
      add(Pconfig.getPanel(),constraints2);
      constraints2.weighty = 0.0; // La fila 0 debe estirarse, le ponemos un 1.0
      
      ////////////////jpanel resultados////////////////////
      JPanel panelBotones= new JPanel();
      panelBotones.setLayout(new GridLayout(1,1));
      panelBotones.setBorder(BorderFactory.createLineBorder(Color.black));
      GridBagConstraints constraints3 = new GridBagConstraints();//se genera el grid layout
      constraints3.gridx = 1; // El área de texto empieza en la columna cero.
      constraints3.gridy = 0; // El área de texto empieza en la fila cero
      constraints3.gridwidth =1; // El área de texto ocupa dos columnas.
      constraints3.gridheight = 2; // El área de texto ocupa 2 filas.
      constraints3.fill = GridBagConstraints.VERTICAL;
      constraints3.weighty = 5.0; // La fila 0 debe estirarse, le ponemos un 1.0
      PanelBotones pBotones= new PanelBotones(estanque1,estanque2,num_Estanques);
      panelBotones.add(pBotones.getPanel());
      add(panelBotones,constraints3);
      constraints3.weighty = 0.0; // La fila 0 debe estirarse, le ponemos un 1.0
      
     bomba_entrada.AddSlider(Pconfig.getEditorVoltage().getSlideri(1));
     bomba_salida.AddSlider(Pconfig.getEditorVoltage().getSlideri(2));
     motBomba.set_configuradores(Pconfig);
     motBomba.set_Cbotones(pBotones);
     
     pBotones.set_Motor(motBomba);
      
      
    }
} 

