/** Esta clase modela la valcula de interconexion
 * entre los estanques. Tiene su propio caudal y parámetros que
 * proximamente podran ser modifcados desde el programa.
 * 
 */
import java.awt.Color;
import java.awt.Container;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.geom.Rectangle2D;
import javax.swing.text.View;


public class Valvula {
    private double caudal;
    private int area;
    private double alturaAgua=0;
    private final double g=9.14;
    private int cte;//constante definida por el fluido
    private Estanque estanque_entrada;
    private Estanque estanque_salida;
    private int alto;
    private int ancho;
    private Container container;  // Container where the cabina is contained.
    private ViewAgua view1;
    private ViewValvula view;
    
    
    public Valvula(int alt,int anch, int ct,int largo,int pox,int poy)
    {
        alto=alt;
        ancho=anch;
        cte=ct;
        caudal=0.0;
        area=alto*ancho;
        container=null;
        view1 = new ViewAgua(largo,alto,pox,poy);
        view = new ViewValvula(largo,alto,pox,poy,ancho);
     }
    
    public void set_estanques(Estanque estanqueE, Estanque estanqueS)
    {
        estanque_entrada=estanqueE;
        estanque_salida=estanqueS;  
    }
    
    public double get_caudal()
    {
        return caudal;
    }
    
    public int get_area()
    {
        return area;
    }
    
    public int get_alto()
    {
        return alto;
    }
    
    public int get_cte()
    {
        return cte;
    }
    
    public void calculo_caudal()
    {   
        
        if((estanque_entrada.get_altura()-estanque_salida.get_altura())>0){  
            if(estanque_entrada.get_altura()>alto)
                caudal= (cte*area* Math.sqrt(2*g*(estanque_entrada.get_altura()-estanque_salida.get_altura())));//cte*area*(2g(H1-H2))^(1/2)
            else
               // caudal= estanque_entrada.get_caudal();
                caudal= (cte*ancho*estanque_entrada.get_altura()* Math.sqrt(2*g*(estanque_entrada.get_altura()-estanque_salida.get_altura())));
                //se utiliza la misma formula que arriba pero el area cambia segun la altura del agua
        }
        else 
            caudal=0.0;
        
        if(estanque_salida.get_altura()>(alto-0.4))
            alturaAgua=alto;
        else
            alturaAgua=estanque_salida.get_altura();
        
        
    }
    
    public void setContainer(Container c){
      container = c;
   }
   public ViewValvula getView() {
      return view;
   }
   
   public ViewAgua getView1() {
      return view1;
   }
    
    public class ViewAgua extends Rectangle2D.Double {
      private int width, height,posx,posy;
      private ViewAgua(int w, int h,int pox,int poy){
        width=w;
        height=h;
        posx=pox;
        posy=poy;
      }
      private void setPosition(){
         setFrame(0.0, 0.0, width, height);      
      }
      public void draw (Graphics2D g){
         Rectangle2D.Double view;
         view = new Rectangle2D.Double(posx-0.1,posy, width+1, alturaAgua);
         g.setColor(new Color(0,0,255));
         g.fill(view);
      }
   }  
    
    public class ViewValvula extends Rectangle2D.Double {
      private int width, height, posx ,posy,larg;
      private ViewValvula(int w, int h,int pox,int poy,int lar){
        width=w;
        height=h;
        posx=pox;
        posy=poy;
        larg=(int) (lar*0.707/2);
        }
      private void setPosition(float position){
         setFrame(posx, posy, width, height);      
      }
      public void draw (Graphics2D g){
         Rectangle2D.Double view;
         view = new Rectangle2D.Double(posx-0.1,posy, width+1, alto);
         g.setColor(new Color(100,100,100));
         g.fill(view);
         g.setColor(new Color(100,100,100));
         g.drawLine(posx,posy,posx+width,posy);
         g.drawLine(posx,posy+alto,posx+width,posy+alto);
         
          //dibujo poligono superior
          g.setColor(new Color(100,100,100));
         int Puntosx1[]={posx,width+posx,width+posx+larg,posx+larg};
         int Puntosy1[]={alto+posy,alto+posy,alto+posy+larg,alto+posy+larg};
         Polygon polygon1=new Polygon(Puntosx1,Puntosy1,4);
         g.fillPolygon(polygon1);
         
         //g.drawArc(posx-4+width,posy, (int) (diametro*0.707),diametro,-110,180);
         
      }
   }
}
